Codeforces Round 954 (Div. 3) F. Non-academic Problem

在这里插入图片描述
思路:考虑缩点,因为是无向图,所以双连通分量缩完点后是一棵树,我们去枚举删除每一条树边的答案,然后取最小值即可。

#include <bits/stdc++.h>

using namespace std;
const int N = 3e5 + 5;
typedef long long ll;
typedef pair<int,int> pll;
typedef array<ll, 3> ar;
int mod = 1e9+7;
const int maxv = 4e6 + 5;
// #define endl "\n"

int n,m;
vector<pll> e[N];
vector<int> e2[N];
vector<vector<int> > vdcc;
int dfsn[N],low[N],tot,b[N],sz[N];
stack<int> s;


void add(int u,int v,int i)
{
	e[u].push_back({v,i});
	e[v].push_back({u,i});
}

void tarjan(int x,int f)//tarjan 求边双连通分量
{
	dfsn[x]=low[x]=++tot,s.push(x);
	for(auto [u,i]: e[x]){
		if(!dfsn[u]){
			tarjan(u,i);
			low[x]=min(low[x],low[u]);
		}
		else if(f!=i) low[x]=min(low[x],dfsn[u]);
	}
	if(dfsn[x]==low[x]){
		vector<int> c;
		while(1){
			auto t=s.top();
			b[t]=vdcc.size();
            sz[vdcc.size()]++;
			c.push_back(t);
			s.pop();
			if(t==x) break;
		}
		vdcc.push_back(c);
	}
}

void init()
{
    tot=0;
    for(int i=0;i<=n;i++){
        e[i].clear();
        e2[i].clear();
        dfsn[i]=b[i]=sz[i]=low[i]=0;
    }
    vdcc.clear();
    
}


ll ans=1e18;

int dfs(int x,int f)
{
    ll sum=0;
    for(auto u: e2[x]){
        if(u!=f) sum+=dfs(u,x);
    }
    sum+=sz[x];
    ll res=n-sum;
    ans=min(ans,(sum)*(sum-1)/2+(res-1)*res/2);
    return sum;
}


void solve()
{
    cin>>n>>m;
    init();
    ans=1e18;
    for(int i=1;i<=m;i++){
        int u,v;
        cin>>u>>v;
        add(u,v,i);
    }
    for(int i=1;i<=n;i++){
        if(!dfsn[i]) tarjan(i,-1);
    }
    for(int i=1;i<=n;i++){
        for(auto [j,id]: e[i]){
            if(b[i]!=b[j]){
                e2[b[i]].push_back(b[j]);
                // e2[b[j]].push_back(b[i]);
            }
        }
    }
    dfs(b[1],-1);
    cout<<ans<<endl;
} 


int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    t=1;
    cin>>t;
    while(t--){
        solve();
    }
    system("pause");
    return 0;
}
Codeforces Round 894 (Div. 3) 是一个Codeforces举办的比赛,是第894轮的Div. 3级别比赛。它包含了一系列题目,其中包括题目E. Kolya and Movie Theatre。 根据题目描述,E. Kolya and Movie Theatre问题要求我们给定两个字符串,通过三种操作来让字符串a等于字符串b。这三种操作分别为:交换a中相同位置的字符、交换a中对称位置的字符、交换b中对称位置的字符。我们需要先进行一次预处理,替换a中的字符,然后进行上述三种操作,最终得到a等于b的结果。我们需要计算预处理操作的次数。 根据引用的讨论,当且仅当b[i]==b[n-i-1]时,如果a[i]!=a[n-i-1],需要进行一次操作;否则不需要操作。所以我们可以遍历字符串b的前半部分,判断对应位置的字符是否与后半部分对称,并统计需要进行操作的次数。 以上就是Codeforces Round 894 (Div. 3)的简要说明和题目E. Kolya and Movie Theatre的要求。<span class="em">1</span><span class="em">2</span><span class="em">3</span> #### 引用[.reference_title] - *1* *2* [Codeforces Round #498 (Div. 3) (A+B+C+D+E+F)](https://blog.csdn.net/qq_46030630/article/details/108804114)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v93^chatsearchT3_2"}}] [.reference_item style="max-width: 50%"] - *3* [Codeforces Round 894 (Div. 3)A~E题解](https://blog.csdn.net/gyeolhada/article/details/132491891)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v93^chatsearchT3_2"}}] [.reference_item style="max-width: 50%"] [ .reference_list ]
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值